<?php

declare(strict_types=1);

namespace Dedi\SyliusCustomerReferralPlugin\Domain\Referral\UseCase\Invite;

use Dedi\SyliusCustomerReferralPlugin\Domain\Referral\DTO\ReferralDTO;
use Dedi\SyliusCustomerReferralPlugin\Domain\Referral\Model\InviterModelInterface;

final class InviteInput
{
    /** @var InviterModelInterface */
    private $inviter;

    /** @var string|null */
    private $email;

    public static function create(
        InviterModelInterface $inviter,
        string $email
    ) {
        $input = new self();
        $input->inviter = $inviter;
        $input->email = $email;

        return $input;
    }

    public function getEmail(): ?string
    {
        return $this->email;
    }

    public function toReferralDTO(): ReferralDTO
    {
        return new ReferralDTO($this->inviter, $this->email);
    }
}
